# 1 "<stdin>"
# 1 "<built-in>"
# 1 "<command line>"
# 1 "<stdin>"

!interp
!
!Usage:
!call interp (arg1, arg2 arg3)
!
!Input Parameters:
!
!
!Output Parameters:
!
!
!
!Description:
!
!
!
!>
!-------------------------------------------------
!
!Author: Robert Clapp, ESMB 463, 7230253
!
!Date Created:Sat Jul 12 20:02:06 2003
!
!Purpose:
!
!
module amo_wrap_mod
  use amo_logstretch_mod
  use amo_types_mod
  use sep3d_struct_mod
  use sep_timers_mod
  implicit none
  type(amo_param_type),private,save :: param_amo
  logical, private,save :: in_real,in_fft,out_fft,out_real
  integer, private, save :: ithread,nthread,ng_r(5),ng(5),ng2,ng3,ng4&
    &,ixdist
  type(sep3d), private,save :: data,model
  real, private, pointer,save :: trace(:,:),gamma(:),vp(:)
  integer, external, private :: sseek_block
  contains
  subroutine set_g_v_dist(g,v,idist)
    real,pointer :: g(:),v(:)
    integer :: idist
    ixdist=idist
    gamma=>g
    vp=>v
  end subroutine
  subroutine init_amo(dat,do_logic,itrace)
    type(sep3d) :: dat
    integer :: ierr,itrace
    logical :: do_logic
    call from_param("t_min_log" ,param_amo%t_min_log,dat%o(1))
    param_amo%t_min_log=.2
    call from_param("fk_filter" ,param_amo%fk_filter,.false.)
    call from_param("v_min" ,param_amo%v_min,2000.)
    call from_param("f_max" ,param_amo%f_max,60.)
    ng_r=dat%n
    in_fft=.true.
    out_fft=.true.
    in_real=.false.
    out_real=.false.
    data=dat
    param_amo%n(1:3)=(/dat%n(1),data%n(2+itrace:3+itrace)/)
    param_amo%o(1:3)=(/dat%o(1),data%o(2+itrace:3+itrace)/)
    param_amo%d(1:3)=(/dat%d(1),data%d(2+itrace:3+itrace)/)
    call init_amo_logstretch(param_amo,ithread,do_logic)
    allocate(trace(ng_r(1),1))
    ng2=data%n(3)
    ng3=data%n(4)
  end subroutine
  subroutine set_nelem(n)
    integer :: n
    ng4=n
  end subroutine
  logical function amo_transform_from_mspace(n2,rout,cin)
    integer :: n2
    real :: rout(:,:)
    complex :: cin(:,:)
    amo_transform_from_mspace=.false.
    call unstretch_fft(n2,rout, cin)
    amo_transform_from_mspace=.true.
  end function
  logical function amo_transform_to_mspace(n2,din,cout)
    integer :: n2
    real :: din(:,:)
    complex :: cout(:,:)
    amo_transform_to_mspace=.false.
    call stretch_fft(n2,din, cout)
    amo_transform_to_mspace=.true.
  end function
  subroutine amo_get_n1_size(mod,n1out,do_2d,itrace)
    type(sep3d) :: mod
    integer :: n1out,ierr,itrace
    logical :: do_2d
    model=mod
    call init_amo(model,do_2d,itrace)
    n1out=param_amo%n1_cmpxcube
  end subroutine
  subroutine amo_to_zero_loop(adj,add,model,data,space)
    logical :: adj,add
    character(len=*) :: model,data
    type(sep3d) :: space
    integer :: i
! call amo_to_zero(.false.,.false.,model,data,space,ixdist+1)
    call amo_to_zero(adj,add,model,data,space,ixdist)
  end subroutine
  subroutine amo_to_zero(adj,add,model_tag,data_tag,space,idist)
    logical :: adj,add
    character(len=*) :: model_tag,data_tag
    type(sep3d) :: space
    logical :: verb_it
    real, allocatable :: model_t(:,:,:),data_t(:,:,:),temp2dr(:,:)
    complex, allocatable :: model_c(:,:,:),freq(:,:),temp2d(:,:),data_c&
      &(:,:,:)
    integer :: ifreq,i,iy_b,iy_e,ix_b,ix_e,ix_out,ix_in,iy_in,ix,iy&
      &,islice,ith
    integer :: i1,i2, i3, j, j1,j2,j3
    real :: hx(2),hy(2),hxout
    real :: hx_x,hx_0,hy_x,hy_0
    real :: loc,o(5),d(5)
    integer :: ngm(5),nw(5),fw(5),jw(5),nf,n2,n3,n1,idist,ngd(5)
    logical :: bool
    integer t1,t2,t3,t4,t5,t6,t7,ipos
    jw=1
    fw=0
    ngd=space%n
    ngm=ngd
    ngm(4)=1 !
!!write(0,*) "NG SPACE",ng
    nw=space%n
    nf=param_amo%n1_cmpxcube
    n1=ngd(1)
    n2=ngd(2)
    n3=ngd(3)
    o=space%o-space%d
    if (ngm(4) /=1) then
      call seperr("Currently can only handle output 1 hx at a time")
    end if
    bool=init_sep_timers()
    bool=setup_cycle_timer("IO",t1)
    bool=setup_cycle_timer("sshif",t2)
    bool=setup_cycle_timer("reshape",t3)
    bool=setup_cycle_timer("stretch",t4)
    bool=setup_cycle_timer("hx",t5)
    bool=setup_cycle_timer("unstretch",t6)
    bool=setup_cycle_timer("unreshape",t7)
    allocate(temp2dr(n1,n2*n3),temp2d(n2,n3))
    allocate(model_t(n1,n2,n3),freq(nf,n2*n3),data_t(n1,n2,n3),model_c&
      &(n1,n2,n3),data_c(n1,n2,n3))
    if (add .or. .not. adj) then
      call sreed_window(model_tag,3,ngm,(/n1,n2,n3,1/),(/0,0,0,0/),jw,4&
        &,model_t)
    else
      model_t=0.
    end if
    do iy=1,ngd(5)
      do ix=1,ngd(4)
        call start_timer_num(t1)
        call sreed_window(data_tag,5,ngd,(/n1,n2,n3,1,1/),(/0,0,0,ix-1&
          &,iy-1/),jw,4,data_t)
        call stop_timer_num(t1)
!!if(.not. add .and. .not. adj) { !! data_t=0. QUESTION: WHY THIS IS SET T0 ZERO ?
        if (.not. adj) then
          data_t=0.
          hx=(/o(4)+d(4)*(ix-1),o(4)+d(4)*(idist-1)/)
          hy=(/0.,o(4)+d(4)*(iy-1)/)
          param_amo%hx_inp=hx(1)
          param_amo%hy_inp=hy(1)
          param_amo%hx_out=hx(2)
          param_amo%hy_out=hy(2)
          model_c = cmplx(model_t,0.0)
          call sshift(model_c, param_amo, gamma, vp)
          model_t = real(model_c)
          j=0
          do i3=1,n3
! Doing reshape (reshape(data_t,(/n1,n2*n3/)))
            do i2=1,n2
              j=j+1
              temp2dr(:,j)=model_t(:,i2,i3)
            end do
          end do
!!!!!!!!temp2dr=reshape(model_t,(/n1,n2*n3/))
          call stretch_fft(n2*n3,temp2dr, freq)
          do i=1,nf
            temp2d=reshape(freq(i,:),(/n2,n3/))
            call amo_hx_transform(hx,hy,temp2d,.true.,.true.,.true.,i,1&
              &)
            freq(i,:)=reshape(temp2d,(/n2*n3/))
          end do
          call unstretch_fft(n2*n3,temp2dr, freq)
          j=0
          do i3=1,n3
! Doing reshape (reshape(temp2dr,(/n1,n2,n3/)))
            do i2=1,n2
              j=j+1
              model_t(:,i2,i3)=temp2dr(:,j)
            end do
          end do
!!!!!!!!model_t=reshape(temp2dr,(/n1,n2,n3/))
          data_t=data_t+model_t
          call srite_window(data_tag,5,ngd,(/n1,n2,n3,1,1/),(/0,0,0,ix&
            &-1,iy-1/),jw,4,data_t)
        else
          hx=(/o(4)+d(4)*ix,o(4)+d(4)*ix/)
          hy=(/o(4)+d(4)*iy,0./)
          hx=(/o(4)+d(4)*(ix-1),o(4)+d(4)*(idist-1)/)
          hy=(/0.,o(4)+d(4)*(iy-1)/)
          param_amo%hx_inp=hx(2)
          param_amo%hy_inp=hy(2)
          param_amo%hx_out=hx(1)
          param_amo%hy_out=hy(1)
          data_c = cmplx(data_t,0.0)
          call start_timer_num(t2)
          call sshift(data_c, param_amo, gamma, vp)
          call stop_timer_num(t2)
          call start_timer_num(t3)
          data_t = real(data_c)
          j=0
          do i3=1,n3
! Doing reshape (reshape(data_t,(/n1,n2*n3/)))
            do i2=1,n2
              j=j+1
              temp2dr(:,j)=data_t(:,i2,i3)
            end do
          end do
!!!!!!!!temp2dr=reshape(data_t,(/n1,n2*n3/))
          call stop_timer_num(t3)
          call start_timer_num(t4)
          call stretch_fft(n2*n3,temp2dr, freq)
          call stop_timer_num(t4)
          call start_timer_num(t5)
          do i=1,nf
            temp2d=reshape(freq(i,:),(/n2,n3/))
            call amo_hx_transform(hx,hy,temp2d,.true.,.true.,.true.,i,1&
              &)
            freq(i,:)=reshape(temp2d,(/n2*n3/))
          end do
          call stop_timer_num(t5)
          call start_timer_num(t6)
          call unstretch_fft(n2*n3,temp2dr, freq)
          call stop_timer_num(t6)
          call start_timer_num(t7)
          j=0
          do i3=1,n3
! Doing reshape (reshape(temp2dr,(/n1,n2,n3/)))
            do i2=1,n2
              j=j+1
              data_t(:,i2,i3)=temp2dr(:,j)
            end do
          end do
! data_t=reshape(temp2dr,(/n1,n2,n3/))
          model_t=model_t+data_t
          call stop_timer_num(t7)
        end if
!! }
      end do
    end do
    call start_timer_num(t1)
    if (adj) then
      call srite_window(model_tag,3,ngm,(/n1,n2,n3,1/),(/0,0,0,0/),jw,4&
        &,model_t)
    end if
    call stop_timer_num(t1)
    call print_timers()
    deallocate(temp2dr,model_c,model_t,freq,data_t,temp2d,data_c)
    write(0,*) "OUT OF"
  end subroutine
  subroutine amo_hx_transform(hx,hy,cspace,fft_in,fft_out,mult,ifreq,ith&
    &)
    real :: hx(2),hy(2)
    complex :: cspace(:,:)
    logical :: fft_in,fft_out,mult,verbit
    integer :: ifreq,ith
    param_amo%hx_inp=hx(1)
    param_amo%hy_inp=hy(1)
    param_amo%hx_out=hx(2)
    param_amo%hy_out=hy(2)
    if (ifreq-param_amo%ilim >0) then
      call t2t_transform(param_amo, cspace,fft_in,fft_out,mult)
    end if
  end subroutine
  integer function tt_func(ifrom,ito,buf)
    integer :: ifrom,ito,i4,i5
    complex :: buf(:,:)
    real :: junk(1,1),hx(2),hy(2)
    i4=mod(ito-1,ng(4))+1
    i5=mod((ito-1)/ng(4),ng(5))+1
    hx(2)=(i4-1)*model%d(4)+model%o(4)
    hy(2)=(i5-1)*model%d(5)+model%o(5)
    i4=mod(ifrom-1,ng(4))+1
    i5=mod((ifrom-1)/ng(4),ng(5))+1
    hx(1)=(i4-1)*model%d(4)+model%o(4)
    hy(1)=(i5-1)*model%d(5)+model%o(5)
    tt_func=0
  end function
  integer function transform_tt(ifrom,ito,temp,ifreq,ith)
    integer :: i4,i5,ib,ito,ifrom,ifreq,ith
    complex :: temp(:,:)
    real :: hx(2),hy(2)
    real :: in
    logical :: adj
    integer :: i,ia,ir,i1,i2,ix
    transform_tt=0
    i4=mod(ito-1,ng_r(4))+1
    i5=mod((ito-1)/ng_r(4),ng_r(5))+1
    hx(2)=(i4-1)*model%d(4)+model%o(4)
    hy(2)=(i5-1)*model%d(5)+model%o(5)
    i4=mod(ifrom-1,ng_r(4))+1
    i5=mod((ifrom-1)/ng_r(4),ng_r(5))+1
    hx(1)=(i4-1)*model%d(4)+model%o(4)
    hy(1)=(i5-1)*model%d(5)+model%o(5)
    call amo_hx_transform(hx,hy,temp,.true.,.false.,.false.,ifreq,ith)
  end function
end module
