program approx_it
  use sep
  use sep3d_struct_mod
  use amo_wrap_mod
  use amo_interp_mod
  use amo_zero_mod
  use amo_nmo_wrap_mod
!!  use amo_approx_mod
!!  use verb_mod
!!  use butter_filt
  implicit none
  type(sep3d) :: input_s,vel_s,gamma_s,no_tib,output_s
  real, pointer :: locs(:,:)
  real, allocatable :: headers(:,:),tref(:,:)
  complex,allocatable :: mod(:,:,:), pvar(:,:,:),data(:,:),fref(:,:)
  integer, external :: sreed
  integer :: n1,nh,n52,n(5)
  integer :: nf,nd,nt,nbig
  integer :: i,i4,i5,i_f,ibeg,i1,i2,i3,idist
  integer :: time_array_0(8), time_array_1(8)
  real    :: finish_timet, start_timet ,ahx_o_o
  real    :: o(5),d(5),eps,hx(2),hy(2),of
  character(len=128) :: temp1,temp2
  logical :: verb

  call sep_init(SOURCE)
  call init_3d()
  call sep_begin_prog()

  !---------------------
  !READ IN PARAMETERS
  !---------------------
  call init_sep3d("in",input_s,"INPUT")
  n(2:5)=input_s%n(3:6)
  o(2:5)=input_s%o(3:6)
  d(2:5)=input_s%d(3:6)
  n(1)=input_s%n(1)
  o(1)=input_s%o(1)
  d(1)=input_s%d(1)
write(0,*) "running v11 ..."

  call from_param("ix_dist",idist,1)
    write(0,*) "CHECK N",n
    write(0,*) "CHECK O",o
    write(0,*) "CHECK D",d
!  if(idist*2+1 /= n(4) ) then
!    call seperr("expecting input to hve 2*idist+1 hxs")
!  end if

  call init_sep3d(input_s,output_s,"OUTPUT")
  call init_sep3d(output_s,"OUTPUT","FLOAT","REGULAR",n,o,d)
  output_s%n(4:5)=1
  call from_param("ahx_o_o",ahx_o_o)
  output_s%o(4:5)=(/ahx_o_o,0./)
  call sep3d_set_sep3d(output_s)
  call sep3d_write_description("out",output_s)
  

  call from_param("verb",verb,.false.)
  call from_param("eps",eps,.1) 
                                                                                
  !-----------------------------------
  ! Read in data
  !-----------------------------------

  call init_sep3d("gamma",gamma_s,"INPUT")
  call init_sep3d("pvel",vel_s,"INPUT")
  if(gamma_s%n(1) /= input_s%n(1)) &
     call seperr("expecting n1 of gamma to be  nt")
  if(vel_s%n(1) /= input_s%n(1)) &
     call seperr("expecting n1 of velp to be  nt")
  if(sep3d_ndims(gamma_s) /=1) call seperr("expecting a 1-D gamma function")
  if(sep3d_ndims(vel_s)   /=1) call seperr("expecting a 1-D velp  function")
  call init_sep3d(no_tib,"OUTPUT","FLOAT","REGULAR",n,o,d)

  !---------------------
  ! Initialize functions
  !---------------------
  call  init_wrap_amo_nmo(input_s,"vrms",100)

  if(.not. amo_zero_init(no_tib,.true.)) &
    call seperr("trouble initializing amo_zero_init")


  !---------------------
  ! CREATE TEMP FILES
  !---------------------
  call from_history("in",temp1)
  call parcat(temp1,102)
  call auxinout(temp1)
  call from_history("in",temp2)
  call parcat(temp2,102)
  call auxinout(temp2)

  !---------------------
  ! NMO
  !---------------------
  time_array_0 = 0
  time_array_1 = 0
  call date_and_time(values=time_array_0)
  start_timet = time_array_0(3) * 86400.+ time_array_0(5) * 3600  + time_array_0(6) * 60 &
           + time_array_0(7) + 0.001 * time_array_0(8)

  call  amo_nmo("in",temp1,locs,verb)

  call date_and_time(values=time_array_1)
  finish_timet = time_array_0(3) * 86400.+ time_array_1(5) * 3600  + time_array_1(6) * 60 &
            + time_array_1(7) + 0.001 * time_array_1(8)
  write(0,*) "total time for NMO", finish_timet - start_timet

  
  !---------------------
  ! Run approximation
  !---------------------
  time_array_0 = 0
  time_array_1 = 0
  call date_and_time(values=time_array_0)
  start_timet = time_array_0(3) * 86400.+ time_array_0(5) * 3600  + time_array_0(6) * 60 &
           + time_array_0(7) + 0.001 * time_array_0(8)

  call amo_transform_to_zero(temp1,temp2,locs,verb)

  call date_and_time(values=time_array_1)
  finish_timet = time_array_0(3) * 86400.+ time_array_1(5) * 3600  + time_array_1(6) * 60 &
            + time_array_1(7) + 0.001 * time_array_1(8)
  write(0,*) "total time for full PSAMO", finish_timet - start_timet


  !---------------------
  ! Inverse NMO
  !---------------------
  call  amo_unnmo(temp2,"out",idist,verb)

  call sep_end_prog()
write(0,*) "Fin"
end program
