module amo_nmo_wrap_mod
 use sep 
 use amo_nmo_mod
 use sep3d_struct_mod

 character(len=128),private, save :: key1,key2,key3,key4
 logical,private,save :: do_nmo
 type(sep3d),private,save :: irreg_s


 contains


  subroutine init_wrap_amo_nmo(data_s, stag, nsz)
   type(sep3d) :: data_s
   character(len=*) :: stag
   integer :: nsz

    !parameters
    call from_param("nmo_it",do_nmo,.true.)
    call from_param("mx_key",key1,"cmp_x")
    call from_param("my_key",key2,"cmp_y")
    call from_param("hx_key",key3,"h_x")
    call from_param("hy_key",key4,"h_y")


    call amo_nmo_init(data_s,stag,nsz)
    irreg_s=data_s


  end subroutine
  subroutine amo_nmo(intag,outtag,locs,verb)
    type(sep3d)            :: no_head
    character(len=*)       :: intag,outtag
    real, allocatable      :: realcube(:,:),real2(:,:)
    real, allocatable      :: headers(:,:),key(:)
    real, pointer          :: locs(:,:),off(:)
    integer                :: ndone,nblock,nh,i,i_f
    logical                :: verb

!! OJO Changed 1000 by 39 then changed by irreg_s%ntraces                                         

    allocate(realcube(irreg_s%n(1),irreg_s%ntraces))
    allocate(real2(irreg_s%n(1),irreg_s%ntraces))
    ndone=0;
    allocate(headers(4,irreg_s%ntraces),key(irreg_s%ntraces))
    call getch_add_string("in.ignore_gff=1")
    call init_sep3d(intag,no_head,"INPUT")
    allocate(locs(4,irreg_s%ntraces))
    if(irreg_s%ntraces==0) return
    do while (ndone < irreg_s%ntraces)
      nblock=min(irreg_s%ntraces,irreg_s%ntraces-ndone)
      if(nblock/=39) then
         deallocate(realcube,real2,headers)
         allocate(realcube(irreg_s%n(1),nblock))
         allocate(real2(irreg_s%n(1),nblock),headers(4,nblock))
      end if
      call sep3d_grab_headers(intag,no_head,nh,nwind=(/nblock/),fwind=(/ndone/))                                                                                
      call sep3d_grab_key_vals(no_head,trim(key1),key);
      headers(1,:)=key
      call sep3d_grab_key_vals(no_head,trim(key2),key);
      headers(2,:)=key
      call sep3d_grab_key_vals(no_head,trim(key3),key);
      headers(3,:)=key
      call sep3d_grab_key_vals(no_head,trim(key4),key);
      headers(4,:)=key
      allocate(off(size(headers,2)))
      off=2*(sqrt(headers(3,:)**2+headers(4,:)**2))
                                                                                
      if(.not. sep3d_read_data("in",no_head,real2)) &
        call seperr("trouble reading data")
                                                                                
      !nmo
      if(do_nmo) then
        call nmoit(real2,realcube,headers(1,:),headers(2,:),off)
      else
        realcube=real2
      end if
  
      !store the headers
      do i=1,nblock
        locs(1,ndone+i)=headers(1,i)
        locs(2,ndone+i)=headers(2,i)
        locs(3,ndone+i)=headers(3,i)
        locs(4,ndone+i)=headers(4,i)
!!!!!!!!!!!        locs(4,ndone+i)=headers(4,i)
      end do
                                                                                
      call srite(outtag,realcube,size(realcube)*4)
      ndone=ndone+nblock
    end do
    deallocate(realcube,real2)
  end subroutine
 
 subroutine  amo_unnmo(intag,outtag,ixdist,verb)
  character(len=*) :: intag,outtag
  real, allocatable :: realcube(:,:),real2(:,:),x(:,:),y(:,:),off(:)
  integer :: i3,i4,i5,i
  logical                :: verb
  integer :: nm(4),ixdist
  real    :: om(4),dm(4)

  nm(1)=irreg_s%n(1);om(1)=irreg_s%o(1);dm(1)=irreg_s%d(1)
  nm(2)=irreg_s%n(3);om(2)=irreg_s%o(3);dm(2)=irreg_s%d(3)
  nm(3)=irreg_s%n(4);om(3)=irreg_s%o(4);dm(3)=irreg_s%d(4)
  nm(4)=irreg_s%n(5);om(4)=irreg_s%o(5)+ixdist*irreg_s%d(5);dm(4)=irreg_s%d(5)

  allocate(x(nm(2),nm(3)))
  allocate(y(nm(2),nm(3)))
  allocate(off(1))
  allocate(realcube(nm(1),nm(2)))
  allocate(real2(nm(1),nm(2)))
  call sseek(intag,0,0)
  call sseek(outtag,0,0)

  do i=1,nm(2)
    x(i,:)=(i-1)*dm(2)+om(2)
  end do

  do i=1,nm(3)
    y(i,:)=(i-1)*dm(3)+om(3)
  end do

    off=om(4)
    do i4=1,irreg_s%n(4) !loop over cmpy
      call sreed(intag,realcube,size(realcube)*4)
      if(do_nmo) then
        call undo_nmoit(realcube,real2,x(:,i4),y(:,i4),off)
      else
        real2=realcube
      end if
      call srite(outtag,realcube,size(realcube)*4)
    end do
  deallocate(real2,realcube,x,y,off)
end subroutine
end module
