module amo_zero_mod
  use sep3d_struct_mod
  use amo_wrap_mod
  use amo_interp_mod
  use sep
!!  use butter_filt
!!  use verb_mod
!!  use random
  implicit none
  type(sep3d),private,save	:: d_s
  integer, private, save   :: idist
  real, private,save    :: o(5),d(5)
  integer, private,save :: n(5),nf,nt
  type(sep3d),private,save           :: input_s
  real,private,save                  :: eps ,bpl,bph
  real, private, pointer             :: gamma(:),vel(:)
  logical,private,save               :: normalize
  

  contains
  logical function amo_zero_init(d_sin,init_amo)
    type(sep3d) :: d_sin
    integer :: i,i_f
    logical :: init_amo
    real :: out_o,out_d
    amo_zero_init=.false.

    d_s = d_sin
    if(init_amo) call amo_get_n1_size(d_s,nf,.true.,0)
    nt=d_s%n(1)
    o=0;d=1;n(5)=nf
    n(1:4)=d_s%n(2:5)
    o(1:4)=d_s%o(2:5)
    d(1:4)=d_s%d(2:5)
    allocate(gamma(nt))
    allocate(vel(nt))

    call from_param("ix_dist",idist,1)
    call from_param("ahx_o_o",out_o)
    call from_param("ahx_d_o",out_d)
write(0,*) "YOPE",o
    write(0,*) "CHECK O4",out_o,"AA",o(3),"BB",(out_o-o(3))/d(3)
    idist=nint((out_o-o(3))/d(3))+1
    write(0,*) "CHECK O4",nint((out_o-o(3))/out_d),idist,out_o
    call from_param("normalize",normalize,.false.)
    call from_param("eps",eps,.00001)
    call sreed("gamma",gamma,size(gamma)*4)
    call sreed("pvel",vel,size(vel)*4)

    call set_g_v_dist(gamma,vel,idist)
    amo_zero_init=.true.
  end function

subroutine amo_transform_to_zero(intag,outtag,locs,verb)
  character(len=*)    :: intag,outtag
  character(len=128)  :: temp1,temp2,temp3
  real                :: locs(:,:)
  real,allocatable    ::  headers(:,:),tref(:,:)
  integer             :: ndone,nblock,ibeg,i,i2,i3
  logical             :: verb
  integer            :: time_array_0(8), time_array_1(8)
  real                :: finish_timet, start_timet


  allocate(headers(5,size(locs,2)))
  do i=1,size(headers,2)
    headers(1,i)=(locs(1,i)-o(1))/d(1)+1.
    headers(2,i)=(locs(2,i)-o(2))/d(2)+1.
    headers(3,i)=(locs(3,i)-o(3))/d(3)+1.
    headers(4,i)=(locs(4,i)-o(4))/d(4)+1.
    headers(5,i)=(-locs(4,i)-o(4))/d(4)+1.
  end do

 allocate(tref(nt,1))
 tref=1
!   call from_aux(intag,"in",temp1)
 call auxpar("in","s",temp1,trim(intag))
 call parcat(temp1,823)
 call auxinout(temp1)

 call auxpar("in","s",temp2,trim(intag))
 call parcat(temp2,824)
 call auxinout(temp2)
 call auxpar("in","s",temp3,trim(intag))
 call parcat(temp3,825)
 call auxinout(temp3)

 time_array_0 = 0
 time_array_1 = 0
 call date_and_time(values=time_array_0)
 start_timet = time_array_0(3) * 86400.+ time_array_0(5) * 3600  + time_array_0(6) * 60 &
	+ time_array_0(7) + 0.001 * time_array_0(8)
 call amo_interp_real(.true.,.false.,temp1,intag,headers,d_s)
 call date_and_time(values=time_array_1)
 finish_timet = time_array_0(3) * 86400.+ time_array_1(5) * 3600  + time_array_1(6) * 60 &
	+ time_array_1(7) + 0.001 * time_array_1(8)
 write(0,*) "total time ADJ-interp", finish_timet - start_timet
 
 time_array_0 = 0
 time_array_1 = 0
 call date_and_time(values=time_array_0)
 start_timet = time_array_0(3) * 86400.+ time_array_0(5) * 3600  + time_array_0(6) * 60 &
	+ time_array_0(7) + 0.001 * time_array_0(8)
 call amo_to_zero_loop(.true.,.false.,temp2,temp1,d_s)
 call date_and_time(values=time_array_1)
 finish_timet = time_array_0(3) * 86400.+ time_array_1(5) * 3600  + time_array_1(6) * 60 &
	+ time_array_1(7) + 0.001 * time_array_1(8)
 write(0,*) "total time ADJ-PSAMO", finish_timet - start_timet

 if(normalize) then
   time_array_0 = 0
   time_array_1 = 0
   call date_and_time(values=time_array_0)
   start_timet = time_array_0(3) * 86400.+ time_array_0(5) * 3600  + time_array_0(6) * 60 &
	+ time_array_0(7) + 0.001 * time_array_0(8)
   call create_ref_model(d_s,temp3,1.)
   call amo_to_zero_loop(.false.,.false.,temp3,temp1,d_s)
   call amo_interp_real(.false.,.false.,temp1,temp3,headers,d_s) ! temp1 becomes 0 here
   call amo_interp_real(.true.,.false.,temp1,temp3,headers,d_s)
   call amo_to_zero_loop(.true.,.false.,temp3,temp1,d_s)
   call date_and_time(values=time_array_1)
   finish_timet = time_array_0(3) * 86400.+ time_array_1(5) * 3600  + time_array_1(6) * 60 &
	+ time_array_1(7) + 0.001 * time_array_1(8)
 write(0,*) "total time Full-Norm", finish_timet - start_timet
   call divide(d_s,temp2,temp3,outtag)
 else
   call copy(d_s,temp2,outtag)
 end if
end subroutine

subroutine copy(space,tag1,out)
type(sep3d) :: space
character(len=*) :: tag1,out
real :: val
real,allocatable :: buf1(:,:),buf2(:,:)
integer ::i

allocate(buf1(space%n(1),space%n(2)))
allocate(buf2(space%n(1),space%n(2)))
call sseek(tag1,0,0)
call sseek(out,0,0)
do i=1,space%n(3)*(space%n(4)-2*idist)
  call sreed(tag1,buf1,size(buf1)*4)
  call srite(out,buf1,size(buf1)*4)
end do
deallocate(buf1,buf2)
end subroutine


subroutine divide(space,tag1,tag2,out)
type(sep3d) :: space
character(len=*) :: tag1,tag2,out
real :: val
real,allocatable :: buf1(:,:),buf2(:,:)
integer ::i

allocate(buf1(space%n(1),space%n(2)))
allocate(buf2(space%n(1),space%n(2)))
call sseek(tag1,0,0)
call sseek(tag2,0,0)
call sseek(out,0,0)
do i=1,space%n(3)*(space%n(4)-2*idist)
  call sreed(tag1,buf1,size(buf1)*4)
  call sreed(tag2,buf2,size(buf2)*4)
  buf1=buf1/(abs(buf2)+eps)
  call srite(out,buf1,size(buf1)*4)
end do
deallocate(buf1,buf2)
end subroutine


subroutine create_ref_model(space,tag,val)
type(sep3d) :: space
character(len=*) :: tag
real :: val
real,allocatable :: buf(:,:)
integer ::i

allocate(buf(space%n(1),space%n(2)))
buf=val
call sseek(tag,0,0)
do i=1,space%n(3)*(space%n(4)-2*idist)
  call srite(tag,buf,size(buf)*4)
end do
deallocate(buf)
end subroutine


end module
