module amo_interp_mod
use sep3d_struct_mod
implicit none
real, pointer, save,private :: head(:,:)
integer, private,save :: n_m(5),n_d(2)

contains

  integer function interp_op(adj,add,mod_tag,dat_tag,op1,op2,op3,op4&
    &,op5,op6,op7,op8,op9)
    logical,            intent(in) :: adj,add
    character(len=128), intent(in) :: mod_tag,dat_tag
    integer,external,optional :: op1,op2,op3,op4,op5,op6,op7,op8,op9
    integer :: i5
    complex, allocatable :: mod(:,:,:,:,:),dat(:,:)
    integer, external :: sreed_window,srite_window
    integer :: nd(2),jd(2),fd(2),nm(5),jm(5),fm(5)
    
    interp_op=0
    allocate(dat(n_d(1),1), mod(n_m(1),n_m(2),n_m(3),n_m(4),1))
    nd=n_d
    nm=n_m
    nm(5)=1
    nd(2)=1
    fm=0
    fd=0
    jd=1
    jm=1
    do i5=1,n_m(5)
      fd(2)=i5-1
      fm(5)=i5-1
      if(0/=sreed_window(dat_tag,2,n_d,nd,fd,jd,8,dat)) &
        call seperr("trouble reading in model")
      if(0/=sreed_window(mod_tag,5,n_m,nm,fm,jm,8,mod)) &
        call seperr("trouble reading in model")
      call amo_interp(adj,add,mod,dat,head)
      if(0/=srite_window(dat_tag,2,n_d,nd,fd,jd,8,dat)) &
        call seperr("trouble reading in model")
      if(0/=srite_window(mod_tag,5,n_m,nm,fm,jm,8,mod)) &
        call seperr("trouble reading in model")
    end do 
    call sseek(dat_tag,0,0)
    call sseek(mod_tag,0,0)
    deallocate(mod,dat)
  end function


subroutine interp_init(headers,nd,nm)
real, pointer :: headers(:,:)
integer ::  nd(:),nm(:)

n_d(1:2)=nd(1:2)
n_m(1:5)=nm(1:5)
head=>headers

end subroutine


 integer function interp_incore(adj,add,model,data)
   logical, intent(in) :: adj,add
   complex :: model(:),data(:)
   integer :: i,nsz,fd,fm

   call amo_interp_nohy(adj,add,n_m(2),n_m(3),n_m(4),n_d(1),n_d(2),&
      model,data,head)
   interp_incore=0
 end function 

subroutine amo_interp_nohy(adj,add,ncx,ncy,nh,nd,nf,model,data,headers)
  type(sep3d) :: mod_s,dat_s
  integer           :: e1,e2,e3,ncx,ncy,nh,nd,nf
  complex :: model(ncx,ncy,nh,nf)
  complex :: data(nd,nf)
  real :: headers(:,:)
  integer           :: ih,i1,i2,i3,i4,maxsize,nblock,ndone,n(4),i
  real              :: f1,f2,f3
  logical,intent(in):: adj,add

  if(.not. add) then
    if(.not. adj ) data=0
    if(adj ) model=0
  end if

  n(1)=size(model,1)
  n(2)=size(model,2)
  n(3)=size(model,3)
  do ih=1,size(headers,2)



    i1=headers(1,ih)   ; f1=headers(1,ih)-i1;e1=i1+1
    if(i1==n(1) .and.  n(1) /= 1) then; i1=n(1)-1; f1=1.;e1=i1; end if
    if(i1==0)  then; i1=1; f1=0;e1=1; end if

    i2=headers(2,ih)   ; f2=headers(2,ih)-i2;e2=i2+1
    if(i2==n(2) .and.  n(2) /= 1) then; i2=n(2)-1; f2=1.;e2=i2; end if
    if(i2==0)  then; i2=1; f2=0;e2=1; end if
     
    i3=headers(3,ih)   ; f3=headers(3,ih)-i3;e3=i3+1
    if(i3==n(3) .and.  n(3) /= 1) then; i3=n(3)-1; f3=1.;e3=i3; end if
    if(i3==0)  then; i3=1; f3=0;e3=1; end if

    e3=i3
    e2=i2
    e1=i1

    if(i2 > 0 .and. e2 <= n(2) .and. i1 >0 .and. e1 <= n(1) ) then
      if(i3 >0 .and. e3 <= n(3) ) then

        if(.not. adj) then
          data(ih,:)=data(ih,:)+ &
            model(i1,i2,i3,:)*(1.-f1)*(1.-f2)*(1.-f3)
          data(ih,:)=data(ih,:)+&
             model(e1,i2,i3,:)*(f1)*(1.-f2)*(1.-f3)
          data(ih,:)=data(ih,:)+&
            model(i1,e2,i3,:)*(1.-f1)*(f2)*(1.-f3)
          data(ih,:)=data(ih,:)+&
            model(e1,e2,i3,:)*(f1)*(f2)*(1.-f3)

          data(ih,:)=data(ih,:)+ &
            model(i1,i2,e3,:)*(1.-f1)*(1.-f2)*(f3)
          data(ih,:)=data(ih,:)+&
             model(e1,i2,e3,:)*(f1)*(1.-f2)*(f3)
          data(ih,:)=data(ih,:)+&
            model(i1,e2,e3,:)*(1.-f1)*(f2)*(f3)
          data(ih,:)=data(ih,:)+&
            model(e1,e2,e3,:)*(f1)*(f2)*(f3)

        else
          model(i1,i2,i3,:)=model(i1,i2,i3,:)+&
            data(ih,:)*(1.-f1)*(1.-f2)*(1.-f3)
          model(e1,i2,i3,:)=model(e1,i2,i3,:)+&
            data(ih,:)*(f1)*(1.-f2)*(1.-f3)
          model(i1,e2,i3,:)=model(i1,e2,i3,:)+&
            data(ih,:)*(1.-f1)*(f2)*(1.-f3)
          model(e1,e2,i3,:)=model(e1,e2,i3,:)+&
            data(ih,:)*(f1)*(f2)*(1.-f3)

          model(i1,i2,e3,:)=model(i1,i2,e3,:)+&
            data(ih,:)*(1.-f1)*(1.-f2)*(f3)
          model(e1,i2,e3,:)=model(e1,i2,e3,:)+&
            data(ih,:)*(f1)*(1.-f2)*(f3)
          model(i1,e2,e3,:)=model(i1,e2,e3,:)+&
            data(ih,:)*(1.-f1)*(f2)*(f3)
          model(e1,e2,e3,:)=model(e1,e2,e3,:)+&
            data(ih,:)*(f1)*(f2)*(f3)
        end if
      end if
    end if
  end do
  end subroutine
subroutine amo_interp(adj,add,model,data,headers)
  type(sep3d) :: mod_s,dat_s
  complex, allocatable :: model(:,:,:,:,:)
  complex, allocatable :: data(:,:)
  real		    :: headers(:,:)
  integer           :: ih,i1,i2,i3,i4,nf,nh,maxsize,nblock,ndone,n(4),i
  integer           :: e1,e2,e3,e4
  real              :: f1,f2,f3,f4
  logical           :: adj,add

  if(.not. add) then
    if(.not. adj ) data=0
    if(adj ) model=0
  end if

  n(1)=size(model,1)
  n(2)=size(model,2)
  n(3)=size(model,3)
  n(4)=size(model,4)
  do ih=1,size(headers,2)



    i1=headers(1,ih)   ; f1=headers(1,ih)-i1;e1=i1+1
    if(i1==n(1) .and.  n(1) /= 1) then; i1=n(1)-1; f1=1.;e1=i1; end if
    if(i1==0)  then; i1=1; f1=0;e1=1; end if

    i2=headers(2,ih)   ; f2=headers(2,ih)-i2;e2=i2+1
    if(i2==n(2) .and.  n(2) /= 1) then; i2=n(2)-1; f2=1.;e2=i2; end if
    if(i2==0)  then; i2=1; f2=0;e2=1; end if
     
    i3=headers(3,ih)   ; f3=headers(3,ih)-i3;e3=i3+1
    if(i3==n(3) .and.  n(3) /= 1) then; i3=n(3)-1; f3=1.;e3=i3; end if
    if(i3==0)  then; i3=1; f3=0;e3=1; end if

    i4=headers(4,ih)   ; f4=headers(4,ih)-i4;e4=i4+1
    if(i4==0)  then; i4=1; f4=0;e4=1; end if
    if(i4==n(4) .and.  n(4) /= 1) then; i4=n(4)-1; f4=1.;e4=i4; end if

    e4=i4
    e3=i3
    e2=i2
    e1=i1

    if(i2 > 0 .and. e2 <= n(2) .and. i1 >0 .and. e1 <= n(1) ) then
      if(i4 > 0 .and. e4 <= n(4) .and. i3 >0 .and. e3 <= n(3) ) then

        if(.not. adj) then
          data(ih,:)=data(ih,:)+ &
            model(i1,i2,i3,i4,:)*(1.-f1)*(1.-f2)*(1.-f3)*(1.-f4)
          data(ih,:)=data(ih,:)+&
             model(e1,i2,i3,i4,:)*(f1)*(1.-f2)*(1.-f3)*(1.-f4)
          data(ih,:)=data(ih,:)+&
            model(i1,e2,i3,i4,:)*(1.-f1)*(f2)*(1.-f3)*(1.-f4)
          data(ih,:)=data(ih,:)+&
            model(e1,e2,i3,i4,:)*(f1)*(f2)*(1.-f3)*(1.-f4)

          data(ih,:)=data(ih,:)+ &
            model(i1,i2,e3,i4,:)*(1.-f1)*(1.-f2)*(f3)*(1.-f4)
          data(ih,:)=data(ih,:)+&
             model(e1,i2,e3,i4,:)*(f1)*(1.-f2)*(f3)*(1.-f4)
          data(ih,:)=data(ih,:)+&
            model(i1,e2,e3,i4,:)*(1.-f1)*(f2)*(f3)*(1.-f4)
          data(ih,:)=data(ih,:)+&
            model(e1,e2,e3,i4,:)*(f1)*(f2)*(f3)*(1.-f4)

          data(ih,:)=data(ih,:)+ &
            model(i1,i2,i3,e4,:)*(1.-f1)*(1.-f2)*(1.-f3)*(f4)
          data(ih,:)=data(ih,:)+&
             model(e1,i2,i3,e4,:)*(f1)*(1.-f2)*(1.-f3)*(f4)
          data(ih,:)=data(ih,:)+&
            model(i1,e2,i3,e4,:)*(1.-f1)*(f2)*(1.-f3)*(f4)
          data(ih,:)=data(ih,:)+&
            model(e1,e2,i3,e4,:)*(f1)*(f2)*(1.-f3)*(f4)

          data(ih,:)=data(ih,:)+ &
            model(i1,i2,e3,e4,:)*(1.-f1)*(1.-f2)*(f3)*(f4)
          data(ih,:)=data(ih,:)+&
             model(e1,i2,e3,e4,:)*(f1)*(1.-f2)*(f3)*(f4)
          data(ih,:)=data(ih,:)+&
            model(i1,e2,e3,e4,:)*(1.-f1)*(f2)*(f3)*(f4)
          data(ih,:)=data(ih,:)+&
            model(e1,e2,e3,e4,:)*(f1)*(f2)*(f3)*(f4)


        else
          model(i1,i2,i3,i4,:)=model(i1,i2,i3,i4,:)+&
            data(ih,:)*(1.-f1)*(1.-f2)*(1.-f3)*(1.-f4)
          model(e1,i2,i3,i4,:)=model(e1,i2,i3,i4,:)+&
            data(ih,:)*(f1)*(1.-f2)*(1.-f3)*(1.-f4)
          model(i1,e2,i3,i4,:)=model(i1,e2,i3,i4,:)+&
            data(ih,:)*(1.-f1)*(f2)*(1.-f3)*(1.-f4)
          model(e1,e2,i3,i4,:)=model(e1,e2,i3,i4,:)+&
            data(ih,:)*(f1)*(f2)*(1.-f3)*(1.-f4)

          model(i1,i2,e3,i4,:)=model(i1,i2,e3,i4,:)+&
            data(ih,:)*(1.-f1)*(1.-f2)*(f3)*(1.-f4)
          model(e1,i2,e3,i4,:)=model(e1,i2,e3,i4,:)+&
            data(ih,:)*(f1)*(1.-f2)*(f3)*(1.-f4)
          model(i1,e2,e3,i4,:)=model(i1,e2,e3,i4,:)+&
            data(ih,:)*(1.-f1)*(f2)*(f3)*(1.-f4)
          model(e1,e2,e3,i4,:)=model(e1,e2,e3,i4,:)+&
            data(ih,:)*(f1)*(f2)*(f3)*(1.-f4)

          model(i1,i2,i3,e4,:)=model(i1,i2,i3,e4,:)+&
            data(ih,:)*(1.-f1)*(1.-f2)*(1.-f3)*(f4)
          model(e1,i2,i3,e4,:)=model(e1,i2,i3,e4,:)+&
            data(ih,:)*(f1)*(1.-f2)*(1.-f3)*(f4)
          model(i1,e2,i3,e4,:)=model(i1,e2,i3,e4,:)+&
            data(ih,:)*(1.-f1)*(f2)*(1.-f3)*(f4)
          model(e1,e2,i3,e4,:)=model(e1,e2,i3,e4,:)+&
            data(ih,:)*(f1)*(f2)*(1.-f3)*(f4)

          model(i1,i2,e3,e4,:)=model(i1,i2,e3,e4,:)+&
            data(ih,:)*(1.-f1)*(1.-f2)*(f3)*(f4)
          model(e1,i2,e3,e4,:)=model(e1,i2,e3,e4,:)+&
            data(ih,:)*(f1)*(1.-f2)*(f3)*(f4)
          model(i1,e2,e3,e4,:)=model(e1,e2,e3,e4,:)+&
            data(ih,:)*(1.-f1)*(f2)*(f3)*(f4)
          model(e1,e2,e3,e4,:)=model(i1,e2,e3,e4,:)+&
            data(ih,:)*(f1)*(f2)*(f3)*(f4)
        end if
      end if
    end if

    i4=headers(5,ih)   ; f4=headers(5,ih)-i4;e4=i4+1
    if(i4==0)  then; i4=1; f4=0;e4=1; end if
    if(i4==n(4) .and.  n(4) /= 1) then; i4=n(4)-1; f4=1.;e4=i4; end if

    e4=i4
    e3=i3
    e2=i2
    e1=i1

    if(i2 > 0 .and. e2 <= n(2) .and. i1 >0 .and. e1 <= n(1) ) then
      if(i4 > 0 .and. e4 <= n(4) .and. i3 >0 .and. e3 <= n(3) ) then

        if(.not. adj) then
          data(ih,:)=data(ih,:)+ &
            model(i1,i2,i3,i4,:)*(1.-f1)*(1.-f2)*(1.-f3)*(1.-f4)
          data(ih,:)=data(ih,:)+&
             model(e1,i2,i3,i4,:)*(f1)*(1.-f2)*(1.-f3)*(1.-f4)
          data(ih,:)=data(ih,:)+&
            model(i1,e2,i3,i4,:)*(1.-f1)*(f2)*(1.-f3)*(1.-f4)
          data(ih,:)=data(ih,:)+&
            model(e1,e2,i3,i4,:)*(f1)*(f2)*(1.-f3)*(1.-f4)

          data(ih,:)=data(ih,:)+ &
            model(i1,i2,e3,i4,:)*(1.-f1)*(1.-f2)*(f3)*(1.-f4)
          data(ih,:)=data(ih,:)+&
             model(e1,i2,e3,i4,:)*(f1)*(1.-f2)*(f3)*(1.-f4)
          data(ih,:)=data(ih,:)+&
            model(i1,e2,e3,i4,:)*(1.-f1)*(f2)*(f3)*(1.-f4)
          data(ih,:)=data(ih,:)+&
            model(e1,e2,e3,i4,:)*(f1)*(f2)*(f3)*(1.-f4)

          data(ih,:)=data(ih,:)+ &
            model(i1,i2,i3,e4,:)*(1.-f1)*(1.-f2)*(1.-f3)*(f4)
          data(ih,:)=data(ih,:)+&
             model(e1,i2,i3,e4,:)*(f1)*(1.-f2)*(1.-f3)*(f4)
          data(ih,:)=data(ih,:)+&
            model(i1,e2,i3,e4,:)*(1.-f1)*(f2)*(1.-f3)*(f4)
          data(ih,:)=data(ih,:)+&
            model(e1,e2,i3,e4,:)*(f1)*(f2)*(1.-f3)*(f4)

          data(ih,:)=data(ih,:)+ &
            model(i1,i2,e3,e4,:)*(1.-f1)*(1.-f2)*(f3)*(f4)
          data(ih,:)=data(ih,:)+&
             model(e1,i2,e3,e4,:)*(f1)*(1.-f2)*(f3)*(f4)
          data(ih,:)=data(ih,:)+&
            model(i1,e2,e3,e4,:)*(1.-f1)*(f2)*(f3)*(f4)
          data(ih,:)=data(ih,:)+&
            model(e1,e2,e3,e4,:)*(f1)*(f2)*(f3)*(f4)


        else
          model(i1,i2,i3,i4,:)=model(i1,i2,i3,i4,:)+&
            data(ih,:)*(1.-f1)*(1.-f2)*(1.-f3)*(1.-f4)
          model(e1,i2,i3,i4,:)=model(e1,i2,i3,i4,:)+&
            data(ih,:)*(f1)*(1.-f2)*(1.-f3)*(1.-f4)
          model(i1,e2,i3,i4,:)=model(i1,e2,i3,i4,:)+&
            data(ih,:)*(1.-f1)*(f2)*(1.-f3)*(1.-f4)
          model(e1,e2,i3,i4,:)=model(e1,e2,i3,i4,:)+&
            data(ih,:)*(f1)*(f2)*(1.-f3)*(1.-f4)

          model(i1,i2,e3,i4,:)=model(i1,i2,e3,i4,:)+&
            data(ih,:)*(1.-f1)*(1.-f2)*(f3)*(1.-f4)
          model(e1,i2,e3,i4,:)=model(e1,i2,e3,i4,:)+&
            data(ih,:)*(f1)*(1.-f2)*(f3)*(1.-f4)
          model(i1,e2,e3,i4,:)=model(i1,e2,e3,i4,:)+&
            data(ih,:)*(1.-f1)*(f2)*(f3)*(1.-f4)
          model(e1,e2,e3,i4,:)=model(e1,e2,e3,i4,:)+&
            data(ih,:)*(f1)*(f2)*(f3)*(1.-f4)

          model(i1,i2,i3,e4,:)=model(i1,i2,i3,e4,:)+&
            data(ih,:)*(1.-f1)*(1.-f2)*(1.-f3)*(f4)
          model(e1,i2,i3,e4,:)=model(e1,i2,i3,e4,:)+&
            data(ih,:)*(f1)*(1.-f2)*(1.-f3)*(f4)
          model(i1,e2,i3,e4,:)=model(i1,e2,i3,e4,:)+&
            data(ih,:)*(1.-f1)*(f2)*(1.-f3)*(f4)
          model(e1,e2,i3,e4,:)=model(e1,e2,i3,e4,:)+&
            data(ih,:)*(f1)*(f2)*(1.-f3)*(f4)

          model(i1,i2,e3,e4,:)=model(i1,i2,e3,e4,:)+&
            data(ih,:)*(1.-f1)*(1.-f2)*(f3)*(f4)
          model(e1,i2,e3,e4,:)=model(e1,i2,e3,e4,:)+&
            data(ih,:)*(f1)*(1.-f2)*(f3)*(f4)
          model(i1,e2,e3,e4,:)=model(e1,e2,e3,e4,:)+&
            data(ih,:)*(1.-f1)*(f2)*(f3)*(f4)
          model(e1,e2,e3,e4,:)=model(i1,e2,e3,e4,:)+&
            data(ih,:)*(f1)*(f2)*(f3)*(f4)
        end if
      end if
    end if
  end do
  end subroutine

  subroutine amo_interp_real(adj,add,mtag,dtag,headers,d_s)
   logical :: adj,add 
   character(len=*) :: mtag,dtag
   character(len=128) :: tag 
   real :: headers(:,:)
   integer :: i2,b1,b2,b3,b4,e1,e2,e3,e4,nblock,nt,nm(5),nw(5),jw(5),fw(5),nbig,done,fold(5)
   type(sep3d) :: d_s
   real, allocatable  :: dwind(:,:),model(:,:,:,:)
   integer :: in_mem,iloc(4)

   nt=d_s%n(1)
   nm=d_s%n
   nw=nm
   fw=0
   jw=1
   nw(5)=1

  in_mem=-1
  allocate(dwind(nt,1000),model(nt,nm(2),nm(3),nm(4)))

  if(.not. add) then
    if(adj) then
       tag=mtag
       nbig=product(nm(2:5))
    else
       tag=dtag
       nbig=size(headers,2)
    end if
    done=0
    dwind=0
    do while(done< nbig) 
      nblock=min(nbig-done,1000)
      call srite_window(tag,2,(/nt,nbig/),(/nt,nblock/),(/0,done/),(/1,1/),4,dwind)
      done=nblock+done
    end do
  end if


  done =0
  model=0.
  fold(5)=-1 
  do while(done< size(headers,2))
    nblock=min(1000,size(headers,2)-done)
    call sreed_window(dtag,2,(/nt,size(headers,2)/),(/nt,nblock/),(/0,done/),(/1,1/),4,dwind)
    do i2=1,nblock 
      iloc(2)=nint(headers(1,i2+done))
      iloc(3)=nint(headers(2,i2+done))
      iloc(4)=nint(headers(3,i2+done))
      fw(5)=nint(headers(4,i2+done))-1.
      if(fw(5)/=fold(5)) then
        if(fold(5)/=-1) then
          call srite_window(mtag,5,nm,nw,fold,jw,4,model)
        end if
        fold=fw
        call sreed_window(mtag,5,nm,nw,fw,jw,4,model)
      end if
      if(adj) then
         model(:,iloc(2),iloc(3),iloc(4))=model(:,iloc(2),iloc(3),iloc(4))+dwind(:,i2)
      else
         dwind(:,i2)=dwind(:,i2)+model(:,iloc(2),iloc(3),iloc(4))
      end if
    end do
    call srite_window(dtag,2,(/nt,size(headers,2)/),(/nt,nblock/),(/0,done/),(/1,1/),4,dwind)
    done=done+nblock
  end do
  call srite_window(mtag,5,nm,nw,fold,jw,4,model)
  deallocate(dwind,model)
  end subroutine

end module
